#ident "$Header$"
/*
Copyright (c) Members of the EGEE Collaboration. 2004-2010.
See http://www.eu-egee.org/partners for details on the copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/


/*

  !! Automatically generated file
  !! Do not edit, your changes will be discarded upon build
  !! Change the corresponding template file ./src/logevent.c.T

*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <math.h> // log
#include <ctype.h> // isspace

#include "glite/security/glite_gss.h"
#include "glite/jobid/cjobid.h"
#include "glite/lb/notifid.h"
#include "glite/lb/events.h"
#include "glite/lb/context.h"
#include "glite/lb/context-int.h"
#include "glite/lb/ulm_parse.h"

#include "producer.h"
#include "args.h"

    //"    %s -p -l 100000 -j https://localhost/First_JobIV?localhost:7771 -s UserInterface -e jobAbort DG.JOB.ABORT.REASON=\"oops\"\n\n",

// undefine to disable support for -l option
#define ENABLE_REASON_LENGTH

static int flesh_seq(int);
static const struct timeval null_timeval = {0,0};

int main(int argc, char *argv[])
{
	char	/* *fmt,*fname = NULL,*/ *fmt_arg=NULL;
        char	*server = NULL, *code = NULL;
	char	*ff = NULL, *jobid_s = NULL;
	char	*src_instance = NULL;
	int	err = 0/*,i,done = 0,fmtlen*/;
	int     pri = 0, noinc = 0;
	int		use_lbproxy = 0;
	char	*lbproxy_user = NULL;
	char	*lbproxy_store_sock = NULL;
        int 	deb = 0;
#ifdef ENABLE_REASON_LENGTH
	int     elength = 0;
#endif
	edg_wll_Context	ctx;
        edg_wll_Source source;
	edg_wll_EventCode event = EDG_WLL_EVENT_UNDEF;
	edg_wlc_JobId jobid = 0;
	int seq = EDG_WLL_SEQ_NORMAL;
        int (*logev)(edg_wll_Context context,
		     edg_wll_EventCode event,
		     char *fmt, ...);

	/* all possible variables */
	char * LRMS_jobid = NULL;
	edg_wll_Source callee = EDG_WLL_SOURCE_NONE;
	glite_jobid_t child = NULL;
	char * child_event = NULL;
	char * classad = NULL;
	char * cmdid = NULL;
	char * command = NULL;
	char * compute_job = NULL;
	char * descr = NULL;
	char * dest = NULL;
	char * dest_host = NULL;
	char * dest_id = NULL;
	char * dest_instance = NULL;
	char * dest_jobid = NULL;
	uint16_t dest_port = 0;
	char * dest_url = NULL;
	char * destid = NULL;
	edg_wll_Source destination = EDG_WLL_SOURCE_NONE;
	int done_code = -1;
	char * error_desc = NULL;
	char * exit_code = NULL;
	int exit_status = 0;
	int expires = 0;
	char * failure_reason = NULL;
	edg_wll_Source from = EDG_WLL_SOURCE_NONE;
	char * from_host = NULL;
	char * from_instance = NULL;
	char * helper_name = NULL;
	char * helper_params = NULL;
	char * histogram = NULL;
	char * hostname = NULL;
	char * id = NULL;
	char * image = NULL;
	char * jdl = NULL;
	char * job = NULL;
	int job_exit_status = -1;
	int job_pid = 0;
	char * jobstat = NULL;
	char * jobtype = NULL;
	char * local_jobid = NULL;
	char * manager = NULL;
	char * name = NULL;
	char * new_state = NULL;
	int newstate = -1;
	int newsubstate = -1;
	char * node = NULL;
	edg_wll_NotifId notifId = NULL;
	char * ns = NULL;
	int nsubjobs = 0;
	char * old_state = NULL;
	int oldstate = -1;
	int oldsubstate = -1;
	char * operation = NULL;
	struct timeval orig_timestamp = null_timeval;
	char * owner = NULL;
	glite_jobid_t parent = NULL;
	char * payload_owner = NULL;
	char * permission = NULL;
	char * permission_type = NULL;
	int pid = 0;
	char * preempting = NULL;
	double quantity = 0;
	char * queue = NULL;
	char * reason = NULL;
	char * require = NULL;
	char * resource = NULL;
	edg_wll_TagValue * resources = NULL;
	char * result = NULL;
	char * retval = NULL;
	char * sandbox_type = NULL;
	char * scheduler = NULL;
	char * seed = NULL;
	int shadow_exit_status = -1;
	char * shadow_host = NULL;
	int shadow_pid = 0;
	uint16_t shadow_port = 0;
	char * shadow_status = NULL;
	char * src = NULL;
	char * src_role = NULL;
	int starter_exit_status = -1;
	int starter_pid = 0;
	char * state = NULL;
	char * status_code = NULL;
	char * svc_host = NULL;
	char * svc_name = NULL;
	uint16_t svc_port = 0;
	char * tag = NULL;
	char * transfer_job = NULL;
	char * unit = NULL;
	char * universe = NULL;
	char * usage = NULL;
	char * user_id = NULL;
	char * user_id_type = NULL;
	char * value = NULL;
	char * wms_dn = NULL;
	char * wn_seq = NULL;
	char * worker_node = NULL;

	/* all possible arguments */
	edg_wll_Args parray[] = {
	    { EDG_WLL_ARGS_EVENT, "e", "event", "select event type (see -e help)", &event },
	    { EDG_WLL_ARGS_BOOL, "p", "priority", "send as priority event", &pri },
	    { EDG_WLL_ARGS_BOOL, "x", "lbproxy", "send directly to L&B Proxy (not locallogger)", &use_lbproxy },
	    { EDG_WLL_ARGS_STRING, "S", "lbproxy-store-sock", "L&B Proxy store socket path", &lbproxy_store_sock },
	    { EDG_WLL_ARGS_STRING, "U", "lbproxy-user-dn", "User certificate DN L&B Proxy store socket path", &lbproxy_user },

	    { EDG_WLL_ARGS_STRING, "m", "machine", 0, &server },
	    { EDG_WLL_ARGS_SOURCE, "s", "source", "event source (see -s help)", &source },
	    { EDG_WLL_ARGS_STRING, "i", "source-instance", "event source instance", &src_instance },
	    { EDG_WLL_ARGS_STRING, "j", "jobid", "JobId", &jobid_s },
	    { EDG_WLL_ARGS_STRING, "c", "sequence", "event sequence code", &code },
	    { EDG_WLL_ARGS_BOOL, "d", "debug mode", "enable debug mode", &deb },
#ifdef ENABLE_REASON_LENGTH
	    { EDG_WLL_ARGS_INT, "l", "reason-length", "extend 'reason' string to length (debug only)", &elength, 0, 1000000000 },
	    { EDG_WLL_ARGS_BOOL, "I", "dont-increment", "don't increment initial seqence code", &noinc },
#endif
	    { EDG_WLL_ARGS_STRING, 0, "LRMS_jobid", "jobId from the LRMS", &LRMS_jobid },
	    { EDG_WLL_ARGS_SOURCE, 0, "callee", "Called component", &callee },
	    { EDG_WLL_ARGS_JOBID, 0, "child", "JobId of subjob, which triggered the state change.	", &child },
	    { EDG_WLL_ARGS_STRING, 0, "child_event", "Event which triggered the state change.	", &child_event },
	    { EDG_WLL_ARGS_STRING, 0, "classad", "Application specific checkpoint value.", &classad },
	    { EDG_WLL_ARGS_STRING, 0, "cmdid", "Id of the command, as stored previously", &cmdid },
	    { EDG_WLL_ARGS_STRING, 0, "command", "Command to store", &command },
	    { EDG_WLL_ARGS_STRING, 0, "compute_job", "Jobid of (compute) job the sandbox belongs. Exclusive with transfer_job.", &compute_job },
	    { EDG_WLL_ARGS_STRING, 0, "descr", "More detailed description", &descr },
	    { EDG_WLL_ARGS_STRING, 0, "dest", "Destination of file transfer.", &dest },
	    { EDG_WLL_ARGS_STRING, 0, "dest_host", "Matched host", &dest_host },
	    { EDG_WLL_ARGS_STRING, 0, "dest_id", "Identification of the queue on the CE that the job could be send to.", &dest_id },
	    { EDG_WLL_ARGS_STRING, 0, "dest_instance", "Service (instance) that takes over control of the job.", &dest_instance },
	    { EDG_WLL_ARGS_STRING, 0, "dest_jobid", "Job id as assigned by the receiving software component.", &dest_jobid },
	    { EDG_WLL_ARGS_UINT16, 0, "dest_port", "Port number the notification is sent to.", &dest_port },
	    { EDG_WLL_ARGS_STRING, 0, "dest_url", "Destination URL (preferred over host and port).", &dest_url },
	    { EDG_WLL_ARGS_STRING, 0, "destid", "Destination ID", &destid },
	    { EDG_WLL_ARGS_SOURCE, 0, "destination", "Destination where the job is being transfered to.", &destination },
	    { EDG_WLL_ARGS_INT, 0, "done_code", "In case of (state == Done) contains done code ", &done_code },
	    { EDG_WLL_ARGS_STRING, 0, "error_desc", "Error reason", &error_desc },
	    { EDG_WLL_ARGS_STRING, 0, "exit_code", "Exit code", &exit_code },
	    { EDG_WLL_ARGS_INT, 0, "exit_status", "Exit status", &exit_status },
	    { EDG_WLL_ARGS_INT, 0, "expires", "When the notification expires", &expires },
	    { EDG_WLL_ARGS_STRING, 0, "failure_reason", "Reason for the failure", &failure_reason },
	    { EDG_WLL_ARGS_SOURCE, 0, "from", "The software component that tried to send the job.", &from },
	    { EDG_WLL_ARGS_STRING, 0, "from_host", "Hostname of the component that tried to send the job.", &from_host },
	    { EDG_WLL_ARGS_STRING, 0, "from_instance", "Instance of the component that tried to send the job.", &from_instance },
	    { EDG_WLL_ARGS_STRING, 0, "helper_name", "Name of the called helper component.", &helper_name },
	    { EDG_WLL_ARGS_STRING, 0, "helper_params", "Parameters of the call to the helper component.", &helper_params },
	    { EDG_WLL_ARGS_STRING, 0, "histogram", "User readable histogram; useful for debugging.", &histogram },
	    { EDG_WLL_ARGS_STRING, 0, "hostname", "hostname of physical machine of VM", &hostname },
	    { EDG_WLL_ARGS_STRING, 0, "id", "machine id", &id },
	    { EDG_WLL_ARGS_STRING, 0, "image", "machine image", &image },
	    { EDG_WLL_ARGS_STRING, 0, "jdl", "Job description of the job being registered.", &jdl },
	    { EDG_WLL_ARGS_STRING, 0, "job", "Job description in the receiver's language.", &job },
	    { EDG_WLL_ARGS_INT, 0, "job_exit_status", "Job exit status", &job_exit_status },
	    { EDG_WLL_ARGS_INT, 0, "job_pid", "PID of running job", &job_pid },
	    { EDG_WLL_ARGS_STRING, 0, "jobstat", "Status of the job (the notification content).", &jobstat },
	    { EDG_WLL_ARGS_STRING, 0, "jobtype", "Type of the job being connected (SIMPLE, DAG, PARTITIONABLE etc.).", &jobtype },
	    { EDG_WLL_ARGS_STRING, 0, "local_jobid", "New job id as assigned by the receiving component.", &local_jobid },
	    { EDG_WLL_ARGS_STRING, 0, "manager", "VM manager", &manager },
	    { EDG_WLL_ARGS_STRING, 0, "name", "machine name", &name },
	    { EDG_WLL_ARGS_STRING, 0, "new_state", "New status", &new_state },
	    { EDG_WLL_ARGS_INT, 0, "newstate", "", &newstate },
	    { EDG_WLL_ARGS_INT, 0, "newsubstate", "", &newsubstate },
	    { EDG_WLL_ARGS_STRING, 0, "node", "Node where CREAM job is running", &node },
	    { EDG_WLL_ARGS_NOTIFID, 0, "notifId", "Notification id.", &notifId },
	    { EDG_WLL_ARGS_STRING, 0, "ns", "NetworkServer/CE endpoint etc. handling the newly registered job.", &ns },
	    { EDG_WLL_ARGS_INT, 0, "nsubjobs", "Number of subjobs this job plans to spawn.", &nsubjobs },
	    { EDG_WLL_ARGS_STRING, 0, "old_state", "Old status", &old_state },
	    { EDG_WLL_ARGS_INT, 0, "oldstate", "", &oldstate },
	    { EDG_WLL_ARGS_INT, 0, "oldsubstate", "", &oldsubstate },
	    { EDG_WLL_ARGS_STRING, 0, "operation", "Operation requested to perform with ACL.", &operation },
	    { EDG_WLL_ARGS_TIMEVAL, 0, "orig_timestamp", "Original timestamp of the job state change", &orig_timestamp },
	    { EDG_WLL_ARGS_STRING, 0, "owner", "machine owner", &owner },
	    { EDG_WLL_ARGS_JOBID, 0, "parent", "Grid job id of the parent job registering this new one.", &parent },
	    { EDG_WLL_ARGS_STRING, 0, "payload_owner", "Identity (certificate subject) of the payload owner.", &payload_owner },
	    { EDG_WLL_ARGS_STRING, 0, "permission", "ACL permission to change.", &permission },
	    { EDG_WLL_ARGS_STRING, 0, "permission_type", "Type of permission requested.", &permission_type },
	    { EDG_WLL_ARGS_INT, 0, "pid", "Actual process ID", &pid },
	    { EDG_WLL_ARGS_STRING, 0, "preempting", "Preempting", &preempting },
	    { EDG_WLL_ARGS_DOUBLE, 0, "quantity", "The quantity", &quantity },
	    { EDG_WLL_ARGS_STRING, 0, "queue", "Queue name", &queue },
	    { EDG_WLL_ARGS_STRING, 0, "reason", "The reason of file transfer failure.", &reason },
	    { EDG_WLL_ARGS_STRING, 0, "require", "machine requirements", &require },
	    { EDG_WLL_ARGS_STRING, 0, "resource", "Resource's name.", &resource },
	    { EDG_WLL_ARGS_TAGLIST, 0, "resources", "List of resources", &resources },
	    { EDG_WLL_ARGS_STRING, 0, "result", "Result code of the file transfer attemp.", &result },
	    { EDG_WLL_ARGS_STRING, 0, "retval", "Data returned by the call to the helper component.", &retval },
	    { EDG_WLL_ARGS_STRING, 0, "sandbox_type", "Type of sandbox.", &sandbox_type },
	    { EDG_WLL_ARGS_STRING, 0, "scheduler", "Scheduler ID", &scheduler },
	    { EDG_WLL_ARGS_STRING, 0, "seed", "Seed for subjob id generation.", &seed },
	    { EDG_WLL_ARGS_INT, 0, "shadow_exit_status", "Exit status of shadow process", &shadow_exit_status },
	    { EDG_WLL_ARGS_STRING, 0, "shadow_host", "Shadow host", &shadow_host },
	    { EDG_WLL_ARGS_INT, 0, "shadow_pid", "PID of shadow process", &shadow_pid },
	    { EDG_WLL_ARGS_UINT16, 0, "shadow_port", "Shadow port", &shadow_port },
	    { EDG_WLL_ARGS_STRING, 0, "shadow_status", "Shadow status", &shadow_status },
	    { EDG_WLL_ARGS_STRING, 0, "src", "Source of file transfer.", &src },
	    { EDG_WLL_ARGS_STRING, 0, "src_role", "The role the event sender is playing in the helper call (CALLING or CALLEE).", &src_role },
	    { EDG_WLL_ARGS_INT, 0, "starter_exit_status", "Exit status of starter process", &starter_exit_status },
	    { EDG_WLL_ARGS_INT, 0, "starter_pid", "PID of starter process", &starter_pid },
	    { EDG_WLL_ARGS_STRING, 0, "state", "New collection state.", &state },
	    { EDG_WLL_ARGS_STRING, 0, "status_code", "", &status_code },
	    { EDG_WLL_ARGS_STRING, 0, "svc_host", "Hostname of the interactive job controller.", &svc_host },
	    { EDG_WLL_ARGS_STRING, 0, "svc_name", "Name of the port instance for interactive job control.", &svc_name },
	    { EDG_WLL_ARGS_UINT16, 0, "svc_port", "Port number of the interactive job controller.", &svc_port },
	    { EDG_WLL_ARGS_STRING, 0, "tag", "Application specific checkpoint tag.", &tag },
	    { EDG_WLL_ARGS_STRING, 0, "transfer_job", "Jobid of transfer job (collection) containing set of file transfers (subjobs).", &transfer_job },
	    { EDG_WLL_ARGS_STRING, 0, "unit", "Units (sec, kB, etc.)", &unit },
	    { EDG_WLL_ARGS_STRING, 0, "universe", "Condor Universe", &universe },
	    { EDG_WLL_ARGS_STRING, 0, "usage", "", &usage },
	    { EDG_WLL_ARGS_STRING, 0, "user_id", "Certificate or VOMS parameter.", &user_id },
	    { EDG_WLL_ARGS_STRING, 0, "user_id_type", "Type of information given in user_id.", &user_id_type },
	    { EDG_WLL_ARGS_STRING, 0, "value", "Arbitrary user tag value.", &value },
	    { EDG_WLL_ARGS_STRING, 0, "wms_dn", "DN of WMS handling the job", &wms_dn },
	    { EDG_WLL_ARGS_STRING, 0, "wn_seq", "Sequence code on the worker node.", &wn_seq },
	    { EDG_WLL_ARGS_STRING, 0, "worker_node", "Worker node", &worker_node },
	    { EDG_WLL_ARGS_HELP },
	    { EDG_WLL_ARGS_NONE },
	};
	edg_wll_ParseArgs(&argc, argv, parray,
			  "Usage: %s [-d] [-p] [[-x] [-S sock] [-U user_dn]] [-l eventlen] [-j dg_jobid]"
			  "[-s source_id] -e event [key=value ...]");


	if (edg_wll_InitContext(&ctx) != 0) {
		fprintf(stderr, "Couldn't create L&B context\n");
		exit(1);
	}

	/* log the event - priority/normal/proxy */
	logev = (pri) ? edg_wll_LogEventSync : edg_wll_LogEvent;
	logev = (use_lbproxy) ? edg_wll_LogEventProxy : logev;

        /* if no job given - generate some */
	if (jobid_s == 0) {
	    	const char* s;
		if (!server) {
		    s = "localhost";
		    err = 1; // result fail if used normaly
		} else
		    s = server;
		edg_wlc_JobIdCreate(s, 0, &jobid);
		jobid_s = edg_wlc_JobIdUnparse(jobid);
		fprintf(stderr, "JobId not given: created %s (server: %s)\n",jobid_s, s);
	}
	else if ((errno = edg_wlc_JobIdParse(jobid_s,&jobid))) {
		perror(jobid_s);
		exit(1);
	}

	if (event == EDG_WLL_EVENT_UNDEF) {
		fprintf(stderr,"%s: unknown or unspecified event\n",argv[0]);
		exit(1);
	}
	edg_wll_SetParam(ctx, EDG_WLL_PARAM_SOURCE, source);
	if (src_instance) edg_wll_SetParam(ctx, EDG_WLL_PARAM_INSTANCE, src_instance);
	edg_wll_SetParam(ctx, EDG_WLL_PARAM_LEVEL,
			 (deb) ? EDG_WLL_LEVEL_DEBUG : EDG_WLL_LEVEL_SYSTEM);

	seq = flesh_seq(event);

	if ( use_lbproxy ) {
		if ( !lbproxy_user ) {
			edg_wll_GssCred		gss_cred = NULL;
			edg_wll_GssStatus   gss_stat;
			if ( edg_wll_gss_acquire_cred_gsi(NULL, NULL, &gss_cred, &gss_stat) )
				lbproxy_user = "anonymous";
                        else
				lbproxy_user = strdup(gss_cred->name);
			if ( gss_cred != NULL ) edg_wll_gss_release_cred(&gss_cred, NULL);
		}
		if ( lbproxy_store_sock )
			edg_wll_SetParam(ctx, EDG_WLL_PARAM_LBPROXY_STORE_SOCK, lbproxy_store_sock);
		if (edg_wll_SetLoggingJobProxy(ctx,jobid,code,lbproxy_user,seq)) {
			char 	*et,*ed;
			edg_wll_Error(ctx,&et,&ed);
			fprintf(stderr,"SetLoggingJobProxy(%s,%s,%s): %s (%s)\n",jobid_s,code,lbproxy_user,et,ed);
			exit(1);
		}
	} else {
		if (edg_wll_SetLoggingJob(ctx,jobid,code,seq)) {
			char 	*et,*ed;
			edg_wll_Error(ctx,&et,&ed);
			fprintf(stderr,"SetLoggingJob(%s,%s): %s (%s)\n",jobid_s,code,et,ed);
			exit(1);
		}
	}

	if (noinc) edg_wll_SetSequenceCode(ctx,code,seq);

#ifdef ENABLE_REASON_LENGTH
	if (elength > 200000000) {
		fprintf(stderr,"%s: usupported reason message length: %d\n", argv[0], elength);
	} else if (elength > 0) {
		int d;
		int i = 0;
		reason = realloc(reason, elength + 1);
                reason[elength] = 0;
		while (i < (elength)) {
                        if ((i % 20) == 0 && (i + 14) < elength)
				i += sprintf(reason + i, "%d", i);
			reason[i++] = '.';
		}
		// amount of decimal digits + "end="
                d = (int)ceil(log(i)/log(10)) + 5;
		if (i > d)
			sprintf(reason + i - (int)(d), "end=%d",i);
		reason[i] = 0;
	}
#endif
#if 0
	if (fname) {
		FILE *f = fopen(fname,"r");
		long s;
                size_t r;

		fmt = "%s FILE.CONTENT=\"%|Us\" ";

		if (!f) { perror(fname); return 1; }
		fseek(f,0L,SEEK_END);
		s = ftell(f); rewind(f);
		ff = (char *) malloc(s+1); if (!ff) { perror(NULL); return 0; }
		r = fread(ff,1,s,f);
		printf("%s: read %d\n",fname,r);
		ff[s] = 0;
		fclose(f);
	}
	else
		fmt = "%s ";
#endif

	//err = edg_wll_LogEvent(ctx, event, fmt, fmt_arg, ff);

	switch (event)
	{
	case EDG_WLL_EVENT_TRANSFER: {
	    char *s_destination;

	    s_destination = edg_wll_SourceToString(destination);
	    //edg_wll_LogTransfer();
	    err |= logev(ctx, EDG_WLL_EVENT_TRANSFER, EDG_WLL_FORMAT_TRANSFER, s_destination, dest_host, dest_instance, job, result, reason, dest_jobid);
	    free(s_destination);
	    }
	    break;
	case EDG_WLL_EVENT_ACCEPTED: {
	    char *s_from;

	    s_from = edg_wll_SourceToString(from);
	    //edg_wll_LogAccepted();
	    err |= logev(ctx, EDG_WLL_EVENT_ACCEPTED, EDG_WLL_FORMAT_ACCEPTED, s_from, from_host, from_instance, local_jobid);
	    free(s_from);
	    }
	    break;
	case EDG_WLL_EVENT_REFUSED: {
	    char *s_from;

	    s_from = edg_wll_SourceToString(from);
	    //edg_wll_LogRefused();
	    err |= logev(ctx, EDG_WLL_EVENT_REFUSED, EDG_WLL_FORMAT_REFUSED, s_from, from_host, from_instance, reason);
	    free(s_from);
	    }
	    break;
	case EDG_WLL_EVENT_ENQUEUED: {

	    //edg_wll_LogEnQueued();
	    err |= logev(ctx, EDG_WLL_EVENT_ENQUEUED, EDG_WLL_FORMAT_ENQUEUED, queue, job, result, reason);
	    }
	    break;
	case EDG_WLL_EVENT_DEQUEUED: {

	    //edg_wll_LogDeQueued();
	    err |= logev(ctx, EDG_WLL_EVENT_DEQUEUED, EDG_WLL_FORMAT_DEQUEUED, queue, local_jobid);
	    }
	    break;
	case EDG_WLL_EVENT_HELPERCALL: {

	    //edg_wll_LogHelperCall();
	    err |= logev(ctx, EDG_WLL_EVENT_HELPERCALL, EDG_WLL_FORMAT_HELPERCALL, helper_name, helper_params, src_role);
	    }
	    break;
	case EDG_WLL_EVENT_HELPERRETURN: {

	    //edg_wll_LogHelperReturn();
	    err |= logev(ctx, EDG_WLL_EVENT_HELPERRETURN, EDG_WLL_FORMAT_HELPERRETURN, helper_name, retval, src_role);
	    }
	    break;
	case EDG_WLL_EVENT_RUNNING: {

	    //edg_wll_LogRunning();
	    err |= logev(ctx, EDG_WLL_EVENT_RUNNING, EDG_WLL_FORMAT_RUNNING, node);
	    }
	    break;
	case EDG_WLL_EVENT_RESUBMISSION: {

	    //edg_wll_LogResubmission();
	    err |= logev(ctx, EDG_WLL_EVENT_RESUBMISSION, EDG_WLL_FORMAT_RESUBMISSION, result, reason, tag);
	    }
	    break;
	case EDG_WLL_EVENT_DONE: {

	    //edg_wll_LogDone();
	    err |= logev(ctx, EDG_WLL_EVENT_DONE, EDG_WLL_FORMAT_DONE, status_code, reason, exit_code);
	    }
	    break;
	case EDG_WLL_EVENT_CANCEL: {

	    //edg_wll_LogCancel();
	    err |= logev(ctx, EDG_WLL_EVENT_CANCEL, EDG_WLL_FORMAT_CANCEL, status_code, reason);
	    }
	    break;
	case EDG_WLL_EVENT_ABORT: {

	    //edg_wll_LogAbort();
	    err |= logev(ctx, EDG_WLL_EVENT_ABORT, EDG_WLL_FORMAT_ABORT, reason);
	    }
	    break;
	case EDG_WLL_EVENT_CLEAR: {

	    //edg_wll_LogClear();
	    err |= logev(ctx, EDG_WLL_EVENT_CLEAR, EDG_WLL_FORMAT_CLEAR, reason);
	    }
	    break;
	case EDG_WLL_EVENT_PURGE: {

	    //edg_wll_LogPurge();
	    err |= logev(ctx, EDG_WLL_EVENT_PURGE, EDG_WLL_FORMAT_PURGE);
	    }
	    break;
	case EDG_WLL_EVENT_MATCH: {

	    //edg_wll_LogMatch();
	    err |= logev(ctx, EDG_WLL_EVENT_MATCH, EDG_WLL_FORMAT_MATCH, dest_id);
	    }
	    break;
	case EDG_WLL_EVENT_PENDING: {

	    //edg_wll_LogPending();
	    err |= logev(ctx, EDG_WLL_EVENT_PENDING, EDG_WLL_FORMAT_PENDING, reason);
	    }
	    break;
	case EDG_WLL_EVENT_REGJOB: {
	    char *s_parent;

	    s_parent = edg_wlc_JobIdUnparse(parent);
	    //edg_wll_LogRegJob();
	    err |= logev(ctx, EDG_WLL_EVENT_REGJOB, EDG_WLL_FORMAT_REGJOB, jdl, ns, s_parent, jobtype, nsubjobs, seed, wms_dn);
	    free(s_parent);
	    }
	    break;
	case EDG_WLL_EVENT_CHKPT: {

	    //edg_wll_LogChkpt();
	    err |= logev(ctx, EDG_WLL_EVENT_CHKPT, EDG_WLL_FORMAT_CHKPT, tag, classad);
	    }
	    break;
	case EDG_WLL_EVENT_LISTENER: {

	    //edg_wll_LogListener();
	    err |= logev(ctx, EDG_WLL_EVENT_LISTENER, EDG_WLL_FORMAT_LISTENER, svc_name, svc_host, svc_port);
	    }
	    break;
	case EDG_WLL_EVENT_CURDESCR: {

	    //edg_wll_LogCurDescr();
	    err |= logev(ctx, EDG_WLL_EVENT_CURDESCR, EDG_WLL_FORMAT_CURDESCR, descr);
	    }
	    break;
	case EDG_WLL_EVENT_USERTAG: {

	    //edg_wll_LogUserTag();
	    err |= logev(ctx, EDG_WLL_EVENT_USERTAG, EDG_WLL_FORMAT_USERTAG, name, value);
	    }
	    break;
	case EDG_WLL_EVENT_CHANGEACL: {

	    //edg_wll_LogChangeACL();
	    err |= logev(ctx, EDG_WLL_EVENT_CHANGEACL, EDG_WLL_FORMAT_CHANGEACL, user_id, user_id_type, permission, permission_type, operation);
	    }
	    break;
	case EDG_WLL_EVENT_NOTIFICATION: {
	    char *s_notifId;

	    s_notifId = edg_wll_NotifIdUnparse(notifId);
	    //edg_wll_LogNotification();
	    err |= logev(ctx, EDG_WLL_EVENT_NOTIFICATION, EDG_WLL_FORMAT_NOTIFICATION, s_notifId, owner, dest_host, dest_port, expires, jobstat, dest_url);
	    free(s_notifId);
	    }
	    break;
	case EDG_WLL_EVENT_RESOURCEUSAGE: {

	    //edg_wll_LogResourceUsage();
	    err |= logev(ctx, EDG_WLL_EVENT_RESOURCEUSAGE, EDG_WLL_FORMAT_RESOURCEUSAGE, resource, quantity, unit);
	    }
	    break;
	case EDG_WLL_EVENT_REALLYRUNNING: {

	    //edg_wll_LogReallyRunning();
	    err |= logev(ctx, EDG_WLL_EVENT_REALLYRUNNING, EDG_WLL_FORMAT_REALLYRUNNING, wn_seq);
	    }
	    break;
	case EDG_WLL_EVENT_SUSPEND: {

	    //edg_wll_LogSuspend();
	    err |= logev(ctx, EDG_WLL_EVENT_SUSPEND, EDG_WLL_FORMAT_SUSPEND, reason);
	    }
	    break;
	case EDG_WLL_EVENT_RESUME: {

	    //edg_wll_LogResume();
	    err |= logev(ctx, EDG_WLL_EVENT_RESUME, EDG_WLL_FORMAT_RESUME, reason);
	    }
	    break;
	case EDG_WLL_EVENT_COLLECTIONSTATE: {
	    char *s_child;

	    s_child = edg_wlc_JobIdUnparse(child);
	    //edg_wll_LogCollectionState();
	    err |= logev(ctx, EDG_WLL_EVENT_COLLECTIONSTATE, EDG_WLL_FORMAT_COLLECTIONSTATE, state, done_code, histogram, s_child, child_event);
	    free(s_child);
	    }
	    break;
	case EDG_WLL_EVENT_GRANTPAYLOADOWNERSHIP: {

	    //edg_wll_LogGrantPayloadOwnership();
	    err |= logev(ctx, EDG_WLL_EVENT_GRANTPAYLOADOWNERSHIP, EDG_WLL_FORMAT_GRANTPAYLOADOWNERSHIP, payload_owner);
	    }
	    break;
	case EDG_WLL_EVENT_TAKEPAYLOADOWNERSHIP: {

	    //edg_wll_LogTakePayloadOwnership();
	    err |= logev(ctx, EDG_WLL_EVENT_TAKEPAYLOADOWNERSHIP, EDG_WLL_FORMAT_TAKEPAYLOADOWNERSHIP);
	    }
	    break;
	case EDG_WLL_EVENT_CONNECTJOB: {

	    //edg_wll_LogConnectJob();
	    err |= logev(ctx, EDG_WLL_EVENT_CONNECTJOB, EDG_WLL_FORMAT_CONNECTJOB, dest_jobid, jobtype);
	    }
	    break;
	case EDG_WLL_EVENT_DISCONNECTJOB: {

	    //edg_wll_LogDisconnectJob();
	    err |= logev(ctx, EDG_WLL_EVENT_DISCONNECTJOB, EDG_WLL_FORMAT_DISCONNECTJOB, dest_jobid);
	    }
	    break;
	case EDG_WLL_EVENT_PBSINTERNALSTATECHANGE: {

	    //edg_wll_LogPBSInternalStateChange();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSINTERNALSTATECHANGE, EDG_WLL_FORMAT_PBSINTERNALSTATECHANGE, oldstate, oldsubstate, newstate, newsubstate);
	    }
	    break;
	case EDG_WLL_EVENT_PBSTRANSFER: {
	    char *s_destination;

	    s_destination = edg_wll_SourceToString(destination);
	    //edg_wll_LogPBSTransfer();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSTRANSFER, EDG_WLL_FORMAT_PBSTRANSFER, s_destination, dest_instance, result, reason, dest_jobid);
	    free(s_destination);
	    }
	    break;
	case EDG_WLL_EVENT_PBSACCEPTED: {
	    char *s_from;

	    s_from = edg_wll_SourceToString(from);
	    //edg_wll_LogPBSAccepted();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSACCEPTED, EDG_WLL_FORMAT_PBSACCEPTED, s_from, from_instance, local_jobid);
	    free(s_from);
	    }
	    break;
	case EDG_WLL_EVENT_PBSREFUSED: {
	    char *s_from;

	    s_from = edg_wll_SourceToString(from);
	    //edg_wll_LogPBSRefused();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSREFUSED, EDG_WLL_FORMAT_PBSREFUSED, s_from, from_instance, reason);
	    free(s_from);
	    }
	    break;
	case EDG_WLL_EVENT_PBSQUEUED: {

	    //edg_wll_LogPBSQueued();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSQUEUED, EDG_WLL_FORMAT_PBSQUEUED, queue, name, owner);
	    }
	    break;
	case EDG_WLL_EVENT_PBSDEQUEUED: {

	    //edg_wll_LogPBSDequeued();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSDEQUEUED, EDG_WLL_FORMAT_PBSDEQUEUED);
	    }
	    break;
	case EDG_WLL_EVENT_PBSMATCH: {

	    //edg_wll_LogPBSMatch();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSMATCH, EDG_WLL_FORMAT_PBSMATCH, dest_host);
	    }
	    break;
	case EDG_WLL_EVENT_PBSPENDING: {

	    //edg_wll_LogPBSPending();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSPENDING, EDG_WLL_FORMAT_PBSPENDING, reason);
	    }
	    break;
	case EDG_WLL_EVENT_PBSWAITING: {

	    //edg_wll_LogPBSWaiting();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSWAITING, EDG_WLL_FORMAT_PBSWAITING);
	    }
	    break;
	case EDG_WLL_EVENT_PBSRUN: {

	    //edg_wll_LogPBSRun();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSRUN, EDG_WLL_FORMAT_PBSRUN, scheduler, dest_host, pid);
	    }
	    break;
	case EDG_WLL_EVENT_PBSRERUN: {

	    //edg_wll_LogPBSRerun();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSRERUN, EDG_WLL_FORMAT_PBSRERUN);
	    }
	    break;
	case EDG_WLL_EVENT_PBSABORT: {

	    //edg_wll_LogPBSAbort();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSABORT, EDG_WLL_FORMAT_PBSABORT);
	    }
	    break;
	case EDG_WLL_EVENT_PBSDONE: {

	    //edg_wll_LogPBSDone();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSDONE, EDG_WLL_FORMAT_PBSDONE, exit_status);
	    }
	    break;
	case EDG_WLL_EVENT_PBSRESOURCEUSAGE: {
	    char *s_resources;

	    s_resources = edg_wll_TagListToString(resources);
	    //edg_wll_LogPBSResourceUsage();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSRESOURCEUSAGE, EDG_WLL_FORMAT_PBSRESOURCEUSAGE, usage, s_resources);
	    free(s_resources);
	    }
	    break;
	case EDG_WLL_EVENT_PBSERROR: {

	    //edg_wll_LogPBSError();
	    err |= logev(ctx, EDG_WLL_EVENT_PBSERROR, EDG_WLL_FORMAT_PBSERROR, error_desc);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORMATCH: {

	    //edg_wll_LogCondorMatch();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORMATCH, EDG_WLL_FORMAT_CONDORMATCH, owner, dest_host, preempting);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORREJECT: {

	    //edg_wll_LogCondorReject();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORREJECT, EDG_WLL_FORMAT_CONDORREJECT, owner, status_code);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORSHADOWSTARTED: {

	    //edg_wll_LogCondorShadowStarted();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORSHADOWSTARTED, EDG_WLL_FORMAT_CONDORSHADOWSTARTED, shadow_host, shadow_port, shadow_pid, shadow_status);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORSHADOWEXITED: {

	    //edg_wll_LogCondorShadowExited();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORSHADOWEXITED, EDG_WLL_FORMAT_CONDORSHADOWEXITED, shadow_pid, shadow_exit_status);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORSTARTERSTARTED: {

	    //edg_wll_LogCondorStarterStarted();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORSTARTERSTARTED, EDG_WLL_FORMAT_CONDORSTARTERSTARTED, starter_pid, universe);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORSTARTEREXITED: {

	    //edg_wll_LogCondorStarterExited();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORSTARTEREXITED, EDG_WLL_FORMAT_CONDORSTARTEREXITED, starter_pid, starter_exit_status, job_pid, job_exit_status);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORRESOURCEUSAGE: {

	    //edg_wll_LogCondorResourceUsage();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORRESOURCEUSAGE, EDG_WLL_FORMAT_CONDORRESOURCEUSAGE, usage, name, quantity, unit);
	    }
	    break;
	case EDG_WLL_EVENT_CONDORERROR: {

	    //edg_wll_LogCondorError();
	    err |= logev(ctx, EDG_WLL_EVENT_CONDORERROR, EDG_WLL_FORMAT_CONDORERROR, error_desc);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMSTART: {

	    //edg_wll_LogCREAMStart();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMSTART, EDG_WLL_FORMAT_CREAMSTART);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMPURGE: {

	    //edg_wll_LogCREAMPurge();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMPURGE, EDG_WLL_FORMAT_CREAMPURGE);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMACCEPTED: {

	    //edg_wll_LogCREAMAccepted();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMACCEPTED, EDG_WLL_FORMAT_CREAMACCEPTED, local_jobid);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMSTORE: {

	    //edg_wll_LogCREAMStore();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMSTORE, EDG_WLL_FORMAT_CREAMSTORE, command, cmdid, result, reason);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMCALL: {
	    char *s_callee;

	    s_callee = edg_wll_SourceToString(callee);
	    //edg_wll_LogCREAMCall();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMCALL, EDG_WLL_FORMAT_CREAMCALL, command, s_callee, cmdid, destid, result, reason);
	    free(s_callee);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMRUNNING: {

	    //edg_wll_LogCREAMRunning();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMRUNNING, EDG_WLL_FORMAT_CREAMRUNNING, node);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMREALLYRUNNING: {

	    //edg_wll_LogCREAMReallyRunning();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMREALLYRUNNING, EDG_WLL_FORMAT_CREAMREALLYRUNNING);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMDONE: {

	    //edg_wll_LogCREAMDone();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMDONE, EDG_WLL_FORMAT_CREAMDONE, status_code, reason, exit_code);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMCANCEL: {

	    //edg_wll_LogCREAMCancel();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMCANCEL, EDG_WLL_FORMAT_CREAMCANCEL, status_code, reason);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMABORT: {

	    //edg_wll_LogCREAMAbort();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMABORT, EDG_WLL_FORMAT_CREAMABORT, reason);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMSTATUS: {
	    char s_orig_timestamp[ULM_DATE_STRING_LENGTH + 1];

	    edg_wll_ULMTimevalToDate((orig_timestamp).tv_sec,(orig_timestamp).tv_usec,s_orig_timestamp);
	    //edg_wll_LogCREAMStatus();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMSTATUS, EDG_WLL_FORMAT_CREAMSTATUS, old_state, new_state, s_orig_timestamp, result, descr, exit_code, failure_reason, worker_node, LRMS_jobid);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMSUSPEND: {

	    //edg_wll_LogCREAMSuspend();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMSUSPEND, EDG_WLL_FORMAT_CREAMSUSPEND, status_code, reason);
	    }
	    break;
	case EDG_WLL_EVENT_CREAMRESUME: {

	    //edg_wll_LogCREAMResume();
	    err |= logev(ctx, EDG_WLL_EVENT_CREAMRESUME, EDG_WLL_FORMAT_CREAMRESUME, status_code, reason);
	    }
	    break;
	case EDG_WLL_EVENT_FILETRANSFERREGISTER: {

	    //edg_wll_LogFileTransferRegister();
	    err |= logev(ctx, EDG_WLL_EVENT_FILETRANSFERREGISTER, EDG_WLL_FORMAT_FILETRANSFERREGISTER, src, dest);
	    }
	    break;
	case EDG_WLL_EVENT_FILETRANSFER: {

	    //edg_wll_LogFileTransfer();
	    err |= logev(ctx, EDG_WLL_EVENT_FILETRANSFER, EDG_WLL_FORMAT_FILETRANSFER, result, reason);
	    }
	    break;
	case EDG_WLL_EVENT_SANDBOX: {

	    //edg_wll_LogSandbox();
	    err |= logev(ctx, EDG_WLL_EVENT_SANDBOX, EDG_WLL_FORMAT_SANDBOX, sandbox_type, transfer_job, compute_job);
	    }
	    break;
	case EDG_WLL_EVENT_VMCREATE: {

	    //edg_wll_LogVMCreate();
	    err |= logev(ctx, EDG_WLL_EVENT_VMCREATE, EDG_WLL_FORMAT_VMCREATE, require, id, name, owner, hostname, manager, image);
	    }
	    break;
	case EDG_WLL_EVENT_VMHOST: {

	    //edg_wll_LogVMHost();
	    err |= logev(ctx, EDG_WLL_EVENT_VMHOST, EDG_WLL_FORMAT_VMHOST, hostname);
	    }
	    break;
	case EDG_WLL_EVENT_VMIMAGE: {

	    //edg_wll_LogVMImage();
	    err |= logev(ctx, EDG_WLL_EVENT_VMIMAGE, EDG_WLL_FORMAT_VMIMAGE, image);
	    }
	    break;
	case EDG_WLL_EVENT_VMRUNNING: {

	    //edg_wll_LogVMRunning();
	    err |= logev(ctx, EDG_WLL_EVENT_VMRUNNING, EDG_WLL_FORMAT_VMRUNNING);
	    }
	    break;
	case EDG_WLL_EVENT_VMSHUTDOWN: {

	    //edg_wll_LogVMShutdown();
	    err |= logev(ctx, EDG_WLL_EVENT_VMSHUTDOWN, EDG_WLL_FORMAT_VMSHUTDOWN, usage);
	    }
	    break;
	case EDG_WLL_EVENT_VMSTOP: {

	    //edg_wll_LogVMStop();
	    err |= logev(ctx, EDG_WLL_EVENT_VMSTOP, EDG_WLL_FORMAT_VMSTOP);
	    }
	    break;
	case EDG_WLL_EVENT_VMRESUME: {

	    //edg_wll_LogVMResume();
	    err |= logev(ctx, EDG_WLL_EVENT_VMRESUME, EDG_WLL_FORMAT_VMRESUME);
	    }
	    break;
	case EDG_WLL_EVENT_VMDONE: {

	    //edg_wll_LogVMDone();
	    err |= logev(ctx, EDG_WLL_EVENT_VMDONE, EDG_WLL_FORMAT_VMDONE, status_code, usage);
	    }
	    break;
	default:
	    fprintf(stderr, "unknown event\n");
	}

	edg_wlc_JobIdFree(jobid);
	if (jobid_s) free(jobid_s); // add all strings

	if (err) {
	    char	*et,*ed;

	    edg_wll_Error(ctx,&et,&ed);
	    fprintf(stderr,"%s: edg_wll_LogEvent*(): %s (%s)\n",
		    argv[0],et,ed);
	    free(et); free(ed);
	}

	code = edg_wll_GetSequenceCode(ctx);
	puts(code);
	free(code);

	edg_wll_FreeContext(ctx);

	if (ff) free(ff);
	if (fmt_arg) free(fmt_arg);
#ifdef ENABLE_REASON_LENGTH
	if (reason) free(reason);
#endif

	return err;
}

static int flesh_seq(int event)
{
	switch (event) {
		case EDG_WLL_EVENT_TRANSFER: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_ACCEPTED: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_REFUSED: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_ENQUEUED: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_DEQUEUED: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_HELPERCALL: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_HELPERRETURN: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_RUNNING: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_RESUBMISSION: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_DONE: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_CANCEL: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_ABORT: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_CLEAR: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_PURGE: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_MATCH: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_PENDING: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_REGJOB: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_CHKPT: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_LISTENER: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_CURDESCR: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_USERTAG: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_CHANGEACL: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_NOTIFICATION: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_RESOURCEUSAGE: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_REALLYRUNNING: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_SUSPEND: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_RESUME: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_COLLECTIONSTATE: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_GRANTPAYLOADOWNERSHIP: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_TAKEPAYLOADOWNERSHIP: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_CONNECTJOB: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_DISCONNECTJOB: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_PBSINTERNALSTATECHANGE: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSTRANSFER: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSACCEPTED: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSREFUSED: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSQUEUED: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSDEQUEUED: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSMATCH: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSPENDING: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSWAITING: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSRUN: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSRERUN: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSABORT: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSDONE: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSRESOURCEUSAGE: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_PBSERROR: return EDG_WLL_SEQ_PBS;
		case EDG_WLL_EVENT_CONDORMATCH: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORREJECT: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORSHADOWSTARTED: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORSHADOWEXITED: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORSTARTERSTARTED: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORSTARTEREXITED: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORRESOURCEUSAGE: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CONDORERROR: return EDG_WLL_SEQ_CONDOR;
		case EDG_WLL_EVENT_CREAMSTART: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMPURGE: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMACCEPTED: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMSTORE: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMCALL: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMRUNNING: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMREALLYRUNNING: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMDONE: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMCANCEL: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMABORT: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMSTATUS: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMSUSPEND: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_CREAMRESUME: return EDG_WLL_SEQ_CREAM;
		case EDG_WLL_EVENT_FILETRANSFERREGISTER: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_FILETRANSFER: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_SANDBOX: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMCREATE: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMHOST: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMIMAGE: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMRUNNING: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMSHUTDOWN: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMSTOP: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMRESUME: return EDG_WLL_SEQ_NORMAL;
		case EDG_WLL_EVENT_VMDONE: return EDG_WLL_SEQ_NORMAL;
	default: return -1;
	}
}
